from django.db.models import QuerySet
from django.db.models.deletion import (
    CASCADE as _CASCADE,
    Collector,
)
from django.db.models.fields.related import RelatedField

from revy import Context


__all__ = (
    'CASCADE',
)


def cascade(
    collector: Collector,
    field: RelatedField,
    sub_objects: QuerySet,
    using: str,
) -> None:
    if Context.get_current() is None:
        return _CASCADE(collector, field, sub_objects, using)
    with Context():
        Context.set_actor(None)
        for sub_object in sub_objects:
            sub_object.delete(using=using)


CASCADE = cascade
