# Generated by Django 4.0.3 on 2022-04-13 04:20

from django.conf import settings
import django.core.serializers.json
from django.db import migrations, models
import django.db.models.deletion
import revy.abc.attribute_delta
import revy.abc.delta
import revy.abc.object_delta
import revy.abc.revision


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        ('contenttypes', '0002_remove_content_type_name'),
    ]

    operations = [
        migrations.CreateModel(
            name='Delta',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('actor_id', models.TextField(blank=True, db_index=True, default=None, null=True)),
                ('action', models.CharField(choices=[('Create', 'Create'), ('Update', 'Update'), ('Delete', 'Delete'), ('Set', 'Set'), ('Unset', 'Unset')], db_index=True, max_length=6)),
                ('content_id', models.TextField(blank=True, db_index=True, default=None, null=True)),
                ('description', models.TextField(blank=True, default='')),
                ('created_at', models.DateTimeField(auto_now_add=True, db_index=True)),
                ('updated_at', models.DateTimeField(auto_now=True, db_index=True)),
                ('actor_type', models.ForeignKey(blank=True, db_column='actor_type_id', null=True, on_delete=django.db.models.deletion.DO_NOTHING, related_name='deltas_created_by', related_query_name='delta_created_by', to='contenttypes.contenttype')),
                ('content_type', models.ForeignKey(blank=True, db_column='content_type_id', null=True, on_delete=django.db.models.deletion.DO_NOTHING, related_name='deltas', related_query_name='delta', to='contenttypes.contenttype')),
            ],
            options={
                'swappable': 'REVY_DELTA_MODEL',
            },
            bases=(revy.abc.delta.Delta, models.Model),
        ),
        migrations.CreateModel(
            name='Revision',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('description', models.TextField(blank=True, default='')),
                ('created_at', models.DateTimeField(auto_now_add=True, db_index=True)),
                ('updated_at', models.DateTimeField(auto_now=True, db_index=True)),
            ],
            options={
                'swappable': 'REVY_REVISION_MODEL',
            },
            bases=(revy.abc.revision.Revision, models.Model),
        ),
        migrations.CreateModel(
            name='ObjectDelta',
            fields=[
                ('delta', models.OneToOneField(db_column='id', on_delete=django.db.models.deletion.CASCADE, parent_link=True, primary_key=True, related_name='object_delta', related_query_name='object_delta', serialize=False, to=settings.REVY_DELTA_MODEL)),
            ],
            options={
                'swappable': 'REVY_OBJECT_DELTA_MODEL',
            },
            bases=(revy.abc.object_delta.ObjectDelta, 'revy.delta', revy.abc.delta.Delta, models.Model),
        ),
        migrations.AddField(
            model_name='delta',
            name='revision',
            field=models.ForeignKey(db_column='revision_id', on_delete=django.db.models.deletion.CASCADE, related_name='deltas', related_query_name='delta', to=settings.REVY_REVISION_MODEL),
        ),
        migrations.CreateModel(
            name='AttributeDelta',
            fields=[
                ('delta', models.OneToOneField(db_column='id', on_delete=django.db.models.deletion.CASCADE, parent_link=True, primary_key=True, related_name='attribute_delta', related_query_name='attribute_delta', serialize=False, to=settings.REVY_DELTA_MODEL)),
                ('field_name', models.TextField(db_index=True)),
                ('old_value', models.JSONField(blank=True, default=None, encoder=django.core.serializers.json.DjangoJSONEncoder, null=True)),
                ('new_value', models.JSONField(blank=True, default=None, encoder=django.core.serializers.json.DjangoJSONEncoder, null=True)),
                ('parent', models.ForeignKey(db_column='parent_id', on_delete=django.db.models.deletion.CASCADE, related_name='children', related_query_name='child', to=settings.REVY_OBJECT_DELTA_MODEL)),
            ],
            options={
                'swappable': 'REVY_ATTRIBUTE_DELTA_MODEL',
            },
            bases=(revy.abc.attribute_delta.AttributeDelta, 'revy.delta', revy.abc.delta.Delta, models.Model),
        ),
    ]
