import dataclasses
from typing import (
    Any,
    Dict,
)


METADATA_NAME = 'revy'


def wrap_metadata(
    **kwargs: Any
) -> Dict[str, Any]:
    return {
        METADATA_NAME: kwargs,
    }


def unwrap_metadata(
    field: dataclasses.Field,
) -> Dict[str, Any]:
    metadata = field.metadata.get(METADATA_NAME, dict())
    return metadata
