import unittest

import revy


class ContextTestCase(unittest.TestCase):

    def test_global_storage(self) -> None:
        self.assertIs(revy.Context._storage, revy.global_storage)

        with revy.Context():
            revy.Context.set_actor(1)

            with revy.Context():
                self.assertEqual(revy.Context.get_actor(), 1)
                revy.Context.set_actor(None)
                self.assertIsNone(revy.Context.get_actor())

            self.assertEqual(revy.Context.get_actor(), 1)
        self.assertIsNone(revy.Context.get_actor())
